=== modified file 'AdapterRegistry.js'
--- AdapterRegistry.js	2007-11-04 18:07:03 +0000
+++ AdapterRegistry.js	2009-11-20 15:08:05 +0000
@@ -1,5 +1,6 @@
-dojo.provide("dojo.AdapterRegistry");
-
+dojo.module(
+	"dojo.AdapterRegistry",
+	function(){
 dojo.AdapterRegistry = function(/*Boolean?*/ returnWrappers){
 	//	summary:
 	//		A registry to make contextual calling/searching easier.
@@ -93,3 +94,5 @@
 		return false;
 	}
 });
+	}
+);

=== modified file 'DeferredList.js'
--- DeferredList.js	2008-10-01 18:35:37 +0000
+++ DeferredList.js	2009-11-20 15:08:05 +0000
@@ -1,4 +1,6 @@
-dojo.provide("dojo.DeferredList");
+dojo.module(
+	"dojo.DeferredList",
+	function(){
 dojo.declare("dojo.DeferredList", dojo.Deferred, {
 	constructor: function(/*Array*/ list, /*Boolean?*/ fireOnOneCallback, /*Boolean?*/ fireOnOneErrback, /*Boolean?*/ consumeErrors, /*Function?*/ canceller){
 		// summary:
@@ -82,3 +84,5 @@
 		return d;
 	}
 });
+	}
+);

=== modified file 'NodeList-fx.js'
--- NodeList-fx.js	2009-04-07 22:22:23 +0000
+++ NodeList-fx.js	2009-11-20 15:08:05 +0000
@@ -1,5 +1,4 @@
-dojo.provide("dojo.NodeList-fx");
-dojo.require("dojo.fx");
+dojo.module("dojo.NodeList-fx", "dojo.fx", function(){
 
 /*=====
 dojo["NodeList-fx"] = {
@@ -131,3 +130,4 @@
 		return canim.play(delay||0); // dojo.Animation
 	}
 });
+});

=== modified file 'NodeList-html.js'
--- NodeList-html.js	2008-08-30 20:26:57 +0000
+++ NodeList-html.js	2009-11-20 15:08:05 +0000
@@ -1,5 +1,4 @@
-dojo.provide("dojo.NodeList-html");
-dojo.require("dojo.html");
+dojo.module("dojo.NodeList-html", "dojo.html", function(){
 
 /*=====
 dojo["NodeList-html"] = {
@@ -36,3 +35,5 @@
 		return this; // dojo.NodeList
 	}
 });
+
+});

=== modified file 'NodeList-manipulate.js'
--- NodeList-manipulate.js	2009-09-30 15:47:23 +0000
+++ NodeList-manipulate.js	2009-11-20 15:08:05 +0000
@@ -1,4 +1,4 @@
-dojo.provide("dojo.NodeList-manipulate");
+dojo.module("dojo.NodeList-manipulate", function(){
 
 /*=====
 dojo["NodeList-manipulate"] = {
@@ -9,7 +9,6 @@
 
 //TODO: add a way to parse for widgets in the injected markup?
 
-(function(){
 	function getText(/*DOMNode*/node){
 		// summary:
 		// 		recursion method for text() to use. Gets text value for a node.
@@ -717,4 +716,4 @@
 	if(!dojo.NodeList.prototype.html){
 		dojo.NodeList.prototype.html = dojo.NodeList.prototype.innerHTML;
 	}
-})();
+});

=== modified file 'NodeList-traverse.js'
--- NodeList-traverse.js	2009-10-20 04:05:07 +0000
+++ NodeList-traverse.js	2009-11-20 15:08:05 +0000
@@ -1,4 +1,4 @@
-dojo.provide("dojo.NodeList-traverse");
+dojo.module("dojo.NodeList-traverse", function(){
 
 /*=====
 dojo["NodeList-traverse"] = {
@@ -504,3 +504,5 @@
 		}); //dojo.NodeList
 	}
 });
+
+});

=== modified file '_base.js'
--- _base.js	2008-02-24 04:52:17 +0000
+++ _base.js	2009-11-20 15:08:05 +0000
@@ -1,9 +1,13 @@
-dojo.provide("dojo._base");
-dojo.require("dojo._base.lang");
-dojo.require("dojo._base.declare");
-dojo.require("dojo._base.connect");
-dojo.require("dojo._base.Deferred");
-dojo.require("dojo._base.json");
-dojo.require("dojo._base.array");
-dojo.require("dojo._base.Color");
-dojo.requireIf(dojo.isBrowser, "dojo._base.browser");
+dojo.module(
+	"dojo._base",
+	[
+		"dojo._base.lang",
+		"dojo._base.declare",
+		"dojo._base.connect",
+		"dojo._base.Deferred",
+		"dojo._base.json",
+		"dojo._base.array",
+		"dojo._base.Color",
+		[ dojo.isBrowser, "dojo._base.browser" ]
+	]
+);

=== modified file '_base/Color.js'
--- _base/Color.js	2009-10-03 15:31:37 +0000
+++ _base/Color.js	2009-11-20 15:08:05 +0000
@@ -1,9 +1,7 @@
-dojo.provide("dojo._base.Color");
-dojo.require("dojo._base.array");
-dojo.require("dojo._base.lang");
-
-(function(){
-
+dojo.module(
+	"dojo._base.Color",
+	["dojo._base.array", "dojo._base.lang"],
+	function(){
 	var d = dojo;
 
 	dojo.Color = function(/*Array|String|Object*/ color){
@@ -213,4 +211,5 @@
 		var a = d.Color.named[str];
 		return a && d.colorFromArray(a, obj) || d.colorFromRgb(str, obj) || d.colorFromHex(str, obj);
 	};
-})();
+	}
+);

=== modified file '_base/Deferred.js'
--- _base/Deferred.js	2009-10-11 03:06:36 +0000
+++ _base/Deferred.js	2009-11-20 15:08:05 +0000
@@ -1,6 +1,7 @@
-dojo.provide("dojo._base.Deferred");
-dojo.require("dojo._base.lang");
-
+dojo.module(
+	"dojo._base.Deferred",
+	"dojo._base.lang",
+	function(){
 dojo.Deferred = function(/*Function?*/ canceller){
 	// summary:
 	//		Encapsulates a sequence of callbacks in response to a value that
@@ -419,3 +420,5 @@
 		}
 	}
 });
+	}
+);

=== modified file '_base/NodeList.js'
--- _base/NodeList.js	2009-10-26 05:40:01 +0000
+++ _base/NodeList.js	2009-11-20 15:08:05 +0000
@@ -1,12 +1,8 @@
-dojo.provide("dojo._base.NodeList");
-dojo.require("dojo._base.lang");
-dojo.require("dojo._base.array");
-
-//>>excludeStart("webkitMobile", kwArgs.webkitMobile);
-(function(){
-
+dojo.module(
+	"dojo._base.NodeList",
+	["dojo._base.lang", "dojo._base.array"],
+	function(){
 	var d = dojo;
-//>>excludeEnd("webkitMobile");
 
 	var ap = Array.prototype, aps = ap.slice, apc = ap.concat;
 
@@ -980,7 +976,5 @@
 				*/
 		}
 	);
-
-//>>excludeStart("webkitMobile", kwArgs.webkitMobile);
-})();
-//>>excludeEnd("webkitMobile");
+	}
+);

=== modified file '_base/_loader/bootstrap.js'
--- _base/_loader/bootstrap.js	2009-11-07 23:42:56 +0000
+++ _base/_loader/bootstrap.js	2009-11-20 15:14:23 +0000
@@ -210,6 +210,88 @@
 		}
 	}
 
+	d.isOwnProperty = function(o, p) {
+		var prop = o.constructor.prototype[p];
+		return typeof prop == 'undefined' || prop !== o[p];
+	};
+
+	// Feature detection
+	var reFeaturedMethod = new RegExp('^(function|object)$', 'i');
+
+	// summary:
+	// Test for host object property referencing an object to be called
+	//
+	// description:
+	// If the referenced object will not be called, use isHostObjectProperty
+	// Allowed properties may be of type function, object (IE and possibly others) or unknown (IE ActiveX methods)
+	// Object types exclude null.
+	//
+	// Does NOT assert that an arbitrary property is callable
+	// Pass only names of properties universally implemented as methods
+	// This does NOT include properties that are methods in some browsers but not others
+	// This test will not discriminate between such implementations and
+	// applications should never call such objects
+	//
+	// example:
+	//
+	// if (dojo.isHostMethod(document, 'getElementById')) {
+	//     anElement = document.getElementById(id);
+	// }
+
+	dojo.isHostMethod = function(/* Host object */ o, /* String */ m) {
+		var t = typeof o[m];
+		return !!((reFeaturedMethod.test(t) && o[m]) || t == 'unknown'); /* Boolean */
+	};
+
+	// summary:
+	// Test for host object property that will be evaluated (e.g. assigned, type converted)
+	//
+	// description:
+	// Similar to isHostMethod, but does not allow unknown types, which are known to throw errors when evaluated
+	// If the property will be called, use isHostMethod
+	//
+	// example:
+	//
+	// if (dojo.isHostObjectProperty(document, 'all')) {
+	//     allElements = document.all;
+	// }
+
+	dojo.isHostObjectProperty = function(/* Host object */ o, /* String */ p) {
+		var t = typeof o[p];
+		return !!(reFeaturedMethod.test(t) && o[p]); /* Boolean */
+	};
+
+	// For application gateways to detect one or more API methods
+
+	dojo.areFeatures = function() {
+		var i = arguments.length;
+		while (i--) {
+			if (!dojo[arguments[i]]) {
+				return false;
+			}
+		}
+		return true;
+	};
+
+	dojo.areNSFeatures = function(ns) {
+		ns = dojo[ns];
+		if (ns) {
+			var features = Array.prototype.slice.call(arguments, 1);
+			var i = features.length;
+			while (i--) {
+				if (!ns[features[i]]) {
+					return false;
+				}
+			}
+			return true;
+		}
+		return false;
+	};
+
+	dojo._getWin = function() {
+		return dojo.global.window || dojo.global;
+	};
+
 /*=====
 	// Override locale setting, if specified
 	dojo.locale = {

=== modified file '_base/_loader/hostenv_browser.js'
--- _base/_loader/hostenv_browser.js	2009-11-15 12:27:52 +0000
+++ _base/_loader/hostenv_browser.js	2009-11-20 15:14:24 +0000
@@ -78,6 +78,23 @@
 		var d = dojo;
 //>>excludeEnd("webkitMobile");
 
+		dojo._loadUri = function(/*String*/uri, /*Function?*/cb){
+			if(d._loadedUrls[uri]){
+				return true; // Boolean
+			}
+			if(d._postLoad){
+				dojo._injectScript(uri);
+			}else{
+				dojo._writeScript(uri);
+			}
+			return true;
+		};
+
+		dojo._writeScript = function(uri){
+			(this.global.window || this.global)
+				.document.write('<script type="text/javascript" src="' + uri + '"></script>');
+		};
+
 		// this is a scope protection closure. We set browser versions and grab
 		// the URL we were loaded from here.
 
@@ -102,10 +119,37 @@
 							dojo.config[x] = cfgo[x];
 						}
 					}
+					(function(sNode){
+						dojo._injectScript = function(uri){
+							s = dojo.doc.createElement('script');
+
+							s.src = uri;
+							s.type = "text/javascript";
+
+							sNode.parentNode.appendChild(s);
+
+							s = null;
+						};
+					})(scripts[i]);
+
 					break; // "first Dojo wins"
 				}
 			}
 		}
+
+		if(typeof dojo._injectScript == "undefined"){
+			dojo._injectScript = function(uri){
+				var head = dojo.doc.getElementsByTagName('head')[0],
+				s = dojo.doc.createElement('script');
+
+				s.src = uri;
+				s.type = "text/javascript";
+
+				head.appendChild(s);
+
+				head = s = null;
+			};
+		}
 		d.baseUrl = d.config.baseUrl;
 
 		// fill in the rendering support information in dojo.render.*
@@ -367,62 +411,55 @@
 	})();
 //>>excludeEnd("webkitMobile");
 
-	//START DOMContentLoaded
 	dojo._initFired = false;
 	dojo._loadInit = function(e){
-		if(!dojo._initFired){
-			dojo._initFired = true;
-
-			//Help out IE to avoid memory leak.
-			if(!dojo.config.afterOnLoad && window.detachEvent){
-				window.detachEvent("onload", dojo._loadInit);
+
+		// NOTE: What is this flag for?
+
+		dojo._initFired = true;
+
+		// allow multiple calls, only first one will take effect
+		// A bug in khtml calls events callbacks for document for events which are not supported
+		// for example a created contextmenu event calls DOMContentLoaded
+
+		var type = e && e.type ? e.type.toLowerCase() : "load";
+		if (!arguments.callee.initialized && (type == "domcontentloaded" || type == "load")){
+			arguments.callee.initialized = true;
+			if (dojo._khtmlTimer){
+				window.clearInterval(dojo._khtmlTimer);
+				delete dojo._khtmlTimer;
 			}
 
-			if(dojo._inFlightCount == 0){
+			if (!dojo._inFlightCount){
 				dojo._modulesLoaded();
 			}
 		}
-	}
-
-	if(!dojo.config.afterOnLoad){
-		if(document.addEventListener){
-			//Standards. Hooray! Assumption here that if standards based,
-			//it knows about DOMContentLoaded. It is OK if it does not, the fall through
-			//to window onload should be good enough.
-			document.addEventListener("DOMContentLoaded", dojo._loadInit, false);
-			window.addEventListener("load", dojo._loadInit, false);
-		}else if(window.attachEvent){
-			window.attachEvent("onload", dojo._loadInit);
-		}
-	}
-
-	//>>excludeStart("webkitMobile", kwArgs.webkitMobile);
-	if(dojo.isIE){
-		// 	for Internet Explorer. readyState will not be achieved on init
-		// 	call, but dojo doesn't need it however, we'll include it
-		// 	because we don't know if there are other functions added that
-		// 	might.  Note that this has changed because the build process
-		// 	strips all comments -- including conditional ones.
-		if(!dojo.config.afterOnLoad && !dojo.config.skipIeDomLoaded){
-			document.write('<scr'+'ipt defer src="//:" '
-				+ 'onreadystatechange="if(this.readyState==\'complete\'){' + dojo._scopeName + '._loadInit();}">'
-				+ '</scr'+'ipt>'
-			);
-		}
-
-		try{
-			document.namespaces.add("v","urn:schemas-microsoft-com:vml");
-			var vmlElems = ["*", "group", "roundrect", "oval", "shape", "rect", "imagedata"],
-				i = 0, l = 1, s = document.createStyleSheet();
-			if(dojo.isIE >= 8){
-				i = 1;
-				l = vmlElems.length;
-			}
-			for(; i < l; ++i){
-				s.addRule("v\\:" + vmlElems[i], "behavior:url(#default#VML);  display:inline-block");
-			}
-		}catch(e){}
-	}
+	};
+
+	var isHostMethod = dojo.isHostMethod,
+		doc = (dojo._getWin()).document,
+		config = dojo.config;
+	if (isHostMethod(window, 'addEventListener')) {
+		window.addEventListener("load", dojo._loadInit, false);
+	} else if (isHostMethod(window, 'attachEvent')) {
+		window.attachEvent("onload", dojo._loadInit);
+	}
+	if (!config.afterOnLoad){
+		if (isHostMethod(doc, 'addEventListener')){				
+			if (config.enableMozDomContentLoaded !== false){
+				doc.addEventListener("DOMContentLoaded", dojo._loadInit, false);
+			}
+		}			
+
+		if (!dojo.isIE && typeof doc.readyState == 'string' && isHostMethod(window, 'setInterval')){
+			dojo._khtmlTimer = window.setInterval(function(){
+				if (/loaded|complete/i.test(window.document.readyState)){
+					dojo._loadInit(); // call the onload handler
+				}
+			}, 10);
+		}
+	}
+
 	//>>excludeEnd("webkitMobile");
 	//END DOMContentLoaded
 

=== modified file '_base/_loader/loader.js'
--- _base/_loader/loader.js	2009-10-04 18:09:15 +0000
+++ _base/_loader/loader.js	2009-11-20 15:14:24 +0000
@@ -10,7 +10,6 @@
 
 	d.mixin(d, {
 		_loadedModules: {},
-		_inFlightCount: 0,
 		_hasResource: {},
 
 		_modulePrefixes: {
@@ -50,6 +49,7 @@
 	});
 
 
+	dojo._protocolPattern = /^\w+:/;
 	//>>excludeStart("xdomainExclude", fileName.indexOf("dojo.xd.js") != -1 && kwArgs.loader == "xdomain");
 	dojo._loadPath = function(/*String*/relpath, /*String?*/module, /*Function?*/cb){
 		// 	summary:
@@ -71,13 +71,16 @@
 		// cb: 
 		//		a callback function to pass the result of evaluating the script
 
-		var uri = ((relpath.charAt(0) == '/' || relpath.match(/^\w+:/)) ? "" : d.baseUrl) + relpath;
-		try{
-			return !module ? d._loadUri(uri, cb) : d._loadUriAndCheck(uri, module, cb); // Boolean
-		}catch(e){
-			console.error(e);
-			return false; // Boolean
+		var absolute = this._protocolPattern.test(relpath) || relpath.charAt(0) == "/";
+		var uri = relpath;
+
+		if(!absolute){
+			uri = this.baseUrl + uri;
+		}else{
+			warn('Path should be relative: ' + relpath + '.');
 		}
+
+		return this._loadUri(uri);
 	}
 
 	dojo._loadUri = function(/*String*/uri, /*Function?*/cb){
@@ -161,18 +164,14 @@
 		//For other xdomain package loads after the initial load.
 		d._loaders = [];
 
+		// Same for required callbacks
+		dojo._requiredCallbacks = {};
+
 		for(var x = 0; x < mll.length; x++){
 			mll[x]();
 		}
 
 		d._loadNotifying = false;
-		
-		//Make sure nothing else got added to the onload queue
-		//after this first run. If something did, and we are not waiting for any
-		//more inflight resources, run again.
-		if(d._postLoad && d._inFlightCount == 0 && mll.length){
-			d._callLoaded();
-		}
 	}
 
 	dojo.unloaded = function(){
@@ -181,10 +180,11 @@
 		//		dojo.addOnUnload() instead of doing a direct dojo.connect() to this 
 		//		method to perform page/application cleanup methods. See 
 		//		dojo.addOnUnload for more info.
-		var mll = d._unloaders;
-		while(mll.length){
-			(mll.pop())();
+		var mll = dojo._unloaders;
+		for(var i = mll.length; i--;){
+			mll[i]();
 		}
+		dojo._unloaders = [];
 	}
 
 	d._onto = function(arr, obj, fn){
@@ -227,14 +227,6 @@
 		//	|	dojo.addOnLoad(object, function(){ doStuff(); });
 
 		d._onto(d._loaders, obj, functionName);
-
-		//Added for xdomain loading. dojo.addOnLoad is used to
-		//indicate callbacks after doing some dojo.require() statements.
-		//In the xdomain case, if all the requires are loaded (after initial
-		//page load), then immediately call any listeners.
-		if(d._postLoad && d._inFlightCount == 0 && !d._loadNotifying){
-			d._callLoaded();
-		}
 	}
 
 	//Support calling dojo.addOnLoad via djConfig.addOnLoad. Support all the
@@ -242,33 +234,46 @@
 	//to the page after the page has loaded.
 	var dca = d.config.addOnLoad;
 	if(dca){
-		d.addOnLoad[(dca instanceof Array ? "apply" : "call")](d, dca);
+		dojo.addOnLoad[Object.prototype.toString.call(dca) == '[object Array]' ? "apply" : "call"](dojo, dca);
 	}
 
 	dojo._modulesLoaded = function(){
 		if(d._postLoad){ return; }
-		if(d._inFlightCount > 0){ 
-			console.warn("files still in flight!");
-			return;
-		}
 		d._callLoaded();
 	}
 
+	// Test for host object properties that are typically callable (e.g. document.getElementById) or known to be callable in some implementations (e.g. document.all in Safari)
+	// which may be of type function, object (IE and possibly others) or unknown (IE ActiveX methods)
+	var isHostMethod = dojo.isHostMethod;
+	var getWin = dojo._getWin;
+
+	if(isHostMethod(getWin(), 'setTimeout')){
+		dojo._setMethodTimeout = function(methodName, delay){
+			var scopeName = dojo._scopeName;
+
+			// NOTE: Why use dojo.global here?
+
+			var space = dojo.global[scopeName];
+			var fn = function(){
+				return space[methodName]();
+			};
+			fn.toString = function(){
+				return 'dojo.global["' + scopeName + '"].' + methodName + '();';
+			};		
+			getWin().setTimeout(fn, delay);
+		};
+	}
+
 	dojo._callLoaded = function(){
-
-		// The "object" check is for IE, and the other opera check fixes an
-		// issue in Opera where it could not find the body element in some
-		// widget test cases.  For 0.9, maybe route all browsers through the
-		// setTimeout (need protection still for non-browser environments
-		// though). This might also help the issue with FF 2.0 and freezing
-		// issues where we try to do sync xhr while background css images are
-		// being loaded (trac #2572)? Consider for 0.9.
-		if(typeof setTimeout == "object" || (d.config.useXDomain && d.isOpera)){
-			setTimeout(
-				d.isAIR ? function(){ d.loaded(); } : d._scopeName + ".loaded();",
-				0);
+		var doc = getWin().document;
+
+		// Make sure the parser has hit the opening body tag
+		// Non-browsers will skip this.
+
+		if(dojo._setMethodTimeout){
+			dojo._setMethodTimeout((doc && doc.body === null) ? '_callLoaded' : 'loaded', 10);
 		}else{
-			d.loaded();
+			dojo.loaded();
 		}
 	}
 
@@ -312,7 +317,19 @@
 		init();
 	}
 
-	dojo._loadModule = dojo.require = function(/*String*/moduleName, /*Boolean?*/omitModuleCheck){
+	dojo._checkRequirements = function(modules, provided) {
+		var ready = true;
+		var checkModules = this[(provided ? '_provided' : '_loaded') + 'Modules'];
+
+		for (var i = modules.length; i--;) {
+			if (!checkModules[modules[i]]) {
+				ready = false;
+			}
+		}
+		return ready;
+	};
+
+	dojo._loadModule = dojo.require = function(/*String|Array*/moduleName, /*Function?*/callback){
 		//	summary:
 		//		loads a Javascript module from the appropriate URI
 		//	moduleName:
@@ -396,38 +413,52 @@
 		//		|	var B = dojo.require("A.B");
 		//	   	|	...
 		//	returns: the required namespace object
-		omitModuleCheck = d._global_omit_module_check || omitModuleCheck;
-
-		//Check if it is already loaded.
-		var module = d._loadedModules[moduleName];
-		if(module){
-			return module;
-		}
-
-		// convert periods to slashes
-		var relpath = d._getModuleSymbols(moduleName).join("/") + '.js';
-
-		var modArg = !omitModuleCheck ? moduleName : null;
-		var ok = d._loadPath(relpath, modArg);
-
-		if(!ok && !omitModuleCheck){
-			throw new Error("Could not load '" + moduleName + "'; last tried '" + relpath + "'");
-		}
-
-		// check that the symbol was defined
-		// Don't bother if we're doing xdomain (asynchronous) loading.
-		if(!omitModuleCheck && !d._isXDomain){
-			// pass in false so we can give better error
-			module = d._loadedModules[moduleName];
-			if(!module){
-				throw new Error("symbol '" + moduleName + "' is not defined after loading '" + relpath + "'"); 
-			}
-		}
-
-		return module;
+		var indeces = [], modules = (typeof moduleName == 'string') ? [moduleName] : moduleName;
+		var len = modules.length;
+		var requiredCallbacks = dojo._requiredCallbacks;
+
+		var requiredCallback = function() {
+			if (dojo._checkRequirements(modules, true)) {
+
+				// All modules in bundle loaded
+
+				callback && callback();				
+
+				for (var i = len; i--;) {
+					requiredCallbacks[modules[i]][indeces[i]] = null;
+				}
+			}
+		};
+
+		if(!dojo._checkRequirements(modules, true)){
+			for(var i = 0; i<len; i++){
+				var doLoad = false;
+				if(!requiredCallbacks[modules[i]]){
+					requiredCallbacks[modules[i]] = [];
+					doLoad = true;
+				}
+				indeces[i] = requiredCallbacks[modules[i]].length;
+				requiredCallbacks[modules[i]].push(requiredCallback);
+				if(doLoad){
+					var relpath = d._getModuleSymbols(modules[i]).join("/") + '.js';
+					dojo._loadPath(relpath);
+				}
+			}
+		}else if(callback){
+			callback();
+		}
 	}
 
-	dojo.provide = function(/*String*/ resourceName){
+	dojo._requiredModules = {};
+	dojo._providedModules = {};
+	dojo._requiredCallbacks = {};
+
+	dojo.module = function(
+		/*String*/ resourceName,
+		/*Array|String*/ requires,
+		/*Array*/ localeBundles,
+		/*Function*/ callback
+	){
 		//	summary:
 		//		Register a resource with the package system. Works in conjunction with `dojo.require`
 		//
@@ -465,8 +496,80 @@
 
 		//Make sure we have a string.
 		resourceName = resourceName + "";
-		return (d._loadedModules[resourceName] = d.getObject(resourceName, true)); // Object
-	}
+
+		if(d._loadedModules[resourceName]){
+			return d._loadedModules[resourceName];
+		}
+		var module = d._loadedModules[resourceName] = d.getObject(resourceName, true);
+
+		if(typeof requires == 'function'){
+			callback = requires;
+			requires = [];
+		}else if(typeof localeBundles == 'function'){
+			callback = localeBundles;
+			localeBundles = [];
+		}
+
+		if(typeof requires == "string"){
+			requires = [requires];
+		}
+
+		var requiredCallbacks = dojo._requiredCallbacks,
+			providedModules = dojo._providedModules;
+
+		var provided = function(){
+			var i, cb, len, result, callbacks = dojo._requiredCallbacks[resourceName];
+
+			if (dojo._providedModules[resourceName]) {
+				throw new Error(rn + " provided more than once.");
+			}
+
+			result = dojo._providedModules[resourceName] = dojo.getObject(resourceName, true);
+
+			callback && callback(result);
+
+			if (callbacks) {
+				len = callbacks.length;
+
+				for (i = 0; i < len; i++) {
+					cb = callbacks[i];
+					if (cb) {
+						cb();
+					}
+				}
+			}
+
+			return result; // Object
+		};
+
+		if(!requires.length){
+			provided();
+			return module;
+		}
+
+		for(var i=requires.length; i--;){
+			var req = requires[i];
+			if(typeof req != "string"){
+				if(typeof req[0] == "function"){
+					if(req[0]() === true){
+						requires.splice(i, 1, req[1]);
+					}else{
+						requires.splice(i, 1);
+					}
+				}else{
+					if(req[0] === true){
+						requires.splice(i, 1, req[1]);
+					}else{
+						requires.splice(i, 1);
+					}
+				}
+			}
+		}
+
+		dojo.require(requires, provided);
+
+		return module;
+	};
 
 	//Start of old bootstrap2:
 
@@ -630,8 +733,10 @@
 		//	|				...
 		//
 
-		d.require("dojo.i18n");
-		d.i18n._requireLocalization.apply(d.hostenv, arguments);
+		var args = arguments;
+		d.require("dojo.i18n", function(){
+			d.i18n._requireLocalization.apply(d.hostenv, args);
+		});
 	};
 
 

=== modified file '_base/array.js'
--- _base/array.js	2009-09-24 17:53:06 +0000
+++ _base/array.js	2009-11-20 15:08:05 +0000
@@ -1,8 +1,7 @@
-dojo.require("dojo._base.lang");
-dojo.provide("dojo._base.array");
-
-//>>excludeStart("webkitMobile", kwArgs.webkitMobile);
-(function(){
+dojo.module(
+	"dojo._base.array",
+	"dojo._base.lang",
+	function(){
 	var _getParts = function(arr, obj, cb){
 		return [ 
 			(typeof arr == "string") ? arr.split("") : arr, 
@@ -247,7 +246,8 @@
 			return outArr; // Array
 		}
 	});
-})();
+	}
+);
 //>>excludeEnd("webkitMobile");
 //>>excludeStart("webkitMobile", kwArgs.webkitMobile);
 /*

=== modified file '_base/browser.js'
--- _base/browser.js	2009-01-05 06:36:02 +0000
+++ _base/browser.js	2009-11-20 15:08:05 +0000
@@ -1,18 +1,13 @@
-dojo.provide("dojo._base.browser");
-
-dojo.require("dojo._base.window");
-dojo.require("dojo._base.connect");
-dojo.require("dojo._base.event");
-dojo.require("dojo._base.html");
-dojo.require("dojo._base.NodeList");
-dojo.require("dojo._base.query");
-dojo.require("dojo._base.xhr");
-dojo.require("dojo._base.fx");
-
-//Need this to be the last code segment in base, so do not place any
-//dojo.requireIf calls in this file. Otherwise, due to how the build system
-//puts all requireIf dependencies after the current file, the require calls
-//could be called before all of base is defined.
-dojo.forEach(dojo.config.require, function(i){
-	dojo["require"](i);
-});
+dojo.module(
+	"dojo._base.browser",
+	["dojo._base.window", "dojo._base.connect", "dojo._base.event", "dojo._base.html", "dojo._base.NodeList", "dojo._base.query", "dojo._base.xhr", "dojo._base.fx"],
+	function(){
+		//Need this to be the last code segment in base, so do not place any
+		//dojo.requireIf calls in this file. Otherwise, due to how the build system
+		//puts all requireIf dependencies after the current file, the require calls
+		//could be called before all of base is defined.
+		dojo.forEach(dojo.config.require, function(i){
+			dojo["require"](i);
+		});
+	}
+);

=== modified file '_base/connect.js'
--- _base/connect.js	2009-10-03 15:19:49 +0000
+++ _base/connect.js	2009-11-20 15:08:05 +0000
@@ -1,8 +1,8 @@
-dojo.provide("dojo._base.connect");
-dojo.require("dojo._base.lang");
-
 // this file courtesy of the TurboAjax Group, licensed under a Dojo CLA
-
+dojo.module(
+	"dojo._base.connect",
+	"dojo._base.lang",
+	function(){
 // low-level delegation machinery
 dojo._listener = {
 	// create a dispatcher function
@@ -314,3 +314,5 @@
 	var pf = function(){ dojo.publish(topic, arguments); }
 	return (event) ? dojo.connect(obj, event, pf) : dojo.connect(obj, pf); //Handle
 };
+	}
+);

=== modified file '_base/declare.js'
--- _base/declare.js	2009-11-14 18:59:35 +0000
+++ _base/declare.js	2009-11-20 15:08:05 +0000
@@ -1,9 +1,7 @@
-dojo.provide("dojo._base.declare");
-
-dojo.require("dojo._base.lang");
-dojo.require("dojo._base.array");
-
-(function(){
+dojo.module(
+	"dojo._base.declare",
+	["dojo._base.lang", "dojo._base.array"],
+	function(){
 	var d = dojo, mix = d._mixin, op = Object.prototype, opts = op.toString,
 		xtor = new Function, counter = 0, cname = "constructor";
 
@@ -970,4 +968,5 @@
 		//	|	});
 	};
 	=====*/
-})();
+	}
+);

=== modified file '_base/event.js'
--- _base/event.js	2009-09-30 20:59:19 +0000
+++ _base/event.js	2009-11-20 15:08:05 +0000
@@ -1,11 +1,7 @@
-dojo.provide("dojo._base.event");
-dojo.require("dojo._base.connect");
-
-// this file courtesy of the TurboAjax Group, licensed under a Dojo CLA
-
-//>>excludeStart("webkitMobile", kwArgs.webkitMobile);
-(function(){
-//>>excludeEnd("webkitMobile");
+dojo.module(
+	"dojo._base.event",
+	"dojo._base.connect",
+	function(){
 	// DOM event listener machinery
 	var del = (dojo._event_listener = {
 		add: function(/*DOMNode*/ node, /*String*/ name, /*Function*/ fp){
@@ -610,14 +606,8 @@
 				return evt;
 			}
 		});
-	//>>excludeStart("webkitMobile", kwArgs.webkitMobile);
-	}
-	//>>excludeEnd("webkitMobile");
-//>>excludeStart("webkitMobile", kwArgs.webkitMobile);
-})();
-//>>excludeEnd("webkitMobile");
-
-//>>excludeStart("webkitMobile", kwArgs.webkitMobile);
+//>>excludeStart("webkitMobile", kwArgs.webkitMobile);
+}
 if(dojo.isIE){
 	// keep this out of the closure
 	// closing over 'iel' or 'ieh' b0rks leak prevention
@@ -652,3 +642,5 @@
 	}
 }
 //>>excludeEnd("webkitMobile");
+	}
+);

=== modified file '_base/fx.js'
--- _base/fx.js	2009-09-21 19:18:26 +0000
+++ _base/fx.js	2009-11-20 15:08:05 +0000
@@ -1,17 +1,12 @@
-dojo.provide("dojo._base.fx");
-dojo.require("dojo._base.Color");
-dojo.require("dojo._base.connect");
-dojo.require("dojo._base.lang");
-dojo.require("dojo._base.html");
-
 /*
 	Animation loosely package based on Dan Pupius' work, contributed under CLA: 
 		http://pupius.co.uk/js/Toolkit.Drawing.js
 */
-//>>excludeStart("webkitMobile", kwArgs.webkitMobile);
-(function(){ 
+dojo.module(
+	"dojo._base.fx",
+	["dojo._base.Color", "dojo._base.connect", "dojo._base.lang", "dojo._base.html"],
+	function(){ 
 	var d = dojo;
-//>>excludeEnd("webkitMobile");
 	var _mixin = d._mixin;
 	
 	dojo._Line = function(/*int*/ start, /*int*/ end){
@@ -380,7 +375,7 @@
 
 		args.node = d.byId(args.node);
 		var fArgs = _mixin({ properties: {} }, args),
-		 	props = (fArgs.properties.opacity = {});
+			props = (fArgs.properties.opacity = {});
 		
 		props.start = !("start" in fArgs) ?
 			function(){ 
@@ -661,6 +656,5 @@
 			onEnd: onEnd 
 		}).play(delay || 0);
 	};
-//>>excludeStart("webkitMobile", kwArgs.webkitMobile);
-})();
-//>>excludeEnd("webkitMobile");
+	}
+);

=== modified file '_base/html.js'
--- _base/html.js	2009-10-18 23:02:30 +0000
+++ _base/html.js	2009-11-20 15:08:05 +0000
@@ -1,6 +1,7 @@
-dojo.require("dojo._base.lang");
-dojo.provide("dojo._base.html");
-
+dojo.module(
+	"dojo._base.html",
+	"dojo._base.lang",
+	function(){
 // FIXME: need to add unit tests for all the semi-public methods
 
 //>>excludeStart("webkitMobile", kwArgs.webkitMobile);
@@ -1086,7 +1087,7 @@
 			var r = de.getBoundingClientRect(); // works well for IE6+
 			//console.debug('rect left,top = ' + r.left+','+r.top + ', html client left/top = ' + de.clientLeft+','+de.clientTop + ', rtl = ' + (!d._isBodyLtr()) + ', quirks = ' + d.isQuirks);
 			var l = r.left,
-			    t = r.top;
+				t = r.top;
 			if(d.isIE < 7){
 				l += de.clientLeft;	// scrollbar size in strict/RTL, or,
 				t += de.clientTop;	// HTML border size in strict
@@ -1867,3 +1868,5 @@
 //>>excludeStart("webkitMobile", kwArgs.webkitMobile);
 })();
 //>>excludeEnd("webkitMobile");
+	}
+);

=== modified file '_base/json.js'
--- _base/json.js	2009-10-03 15:01:44 +0000
+++ _base/json.js	2009-11-20 15:08:05 +0000
@@ -1,5 +1,6 @@
-dojo.provide("dojo._base.json");
-
+dojo.module(
+	"dojo._base.json",
+	function(){
 dojo.fromJson = function(/*String*/ json){
 	// summary:
 	// 		Parses a [JSON](http://json.org) string to return a JavaScript object.
@@ -140,3 +141,5 @@
 	}
 	return "{" + output.join("," + sep) + newLine + _indentStr + "}"; // String
 }
+	}
+);

=== modified file '_base/lang.js'
--- _base/lang.js	2009-11-03 00:17:48 +0000
+++ _base/lang.js	2009-11-20 15:08:05 +0000
@@ -1,6 +1,6 @@
-dojo.provide("dojo._base.lang");
-
-(function(){
+dojo.module(
+	"dojo._base.lang",
+	function(){
 	var d = dojo, opts = Object.prototype.toString;
 
 	// Crockford (ish) functions
@@ -384,4 +384,5 @@
 		return tmpl.replace(pattern || _pattern, d.isFunction(map) ?
 			map : function(_, k){ return d.getObject(k, false, map); });
 	};
-})();
+	}
+);

=== modified file '_base/query-sizzle.js'
--- _base/query-sizzle.js	2009-02-19 00:27:28 +0000
+++ _base/query-sizzle.js	2009-11-20 15:08:05 +0000
@@ -13,9 +13,10 @@
 
 //This file gets copied to dojo/_base/query.js, so set the provide accordingly.
 if(typeof dojo != "undefined"){
-	dojo.provide("dojo._base.query");
-	dojo.require("dojo._base.NodeList");
-
+	dojo.module(
+		"dojo._base.query",
+		"dojo._base.NodeList",
+		function(){
 	//Start Dojo mappings.
 	dojo.query = function(/*String*/ query, /*String|DOMNode?*/ root, /*Function?*/listCtor){
 		listCtor = listCtor || dojo.NodeList;
@@ -41,6 +42,8 @@
 	dojo._filterQueryResult = function(nodeList, simpleFilter){
 		return dojo.Sizzle.filter(simpleFilter, nodeList);
 	}
+		}
+	);
 }
 
 //Main Sizzle code follows...

